%{
	#include <iostream>
	
	#include <cctype>
	#include <cstddef>
	
	extern "C"
	{
		int yylex(void);
		void yyerror(const char *);
	}
	
	#include "main.flex.h"
%}


%token NUMBER
%token PLUS MINUS MUL DIV
%token LEFT RIGHT

%left PLUS MINUS
%left MUL DIV

%start line


%%
	line :
		expr { std::cout << $1 << std::endl; }
	;
	
	expr :
		  NUMBER
		| expr PLUS expr { $$ = $1 + $3; }
		| expr MINUS expr { $$ = $1 - $3; }
		| expr MUL expr { $$ = $1 * $3; }
		| expr DIV expr { $$ = $1 / $3; }
		| LEFT expr RIGHT { $$ = $2; }
	;
%%

int main()
{
	std::cout << ">>> ";
	yyparse();
	
	return 0;
}
